VERSION 5.00
Begin VB.Form frmTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Test Shell And Wait To Notepad"
   ClientHeight    =   5505
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4770
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5505
   ScaleWidth      =   4770
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnClose 
      Caption         =   "Close"
      Height          =   735
      Left            =   2520
      TabIndex        =   6
      Top             =   4560
      Width           =   1335
   End
   Begin VB.Frame fraType 
      Caption         =   "Shell And Wait Function"
      Height          =   1215
      Left            =   240
      TabIndex        =   9
      Top             =   1920
      Width           =   4335
      Begin VB.OptionButton optSimple 
         Caption         =   "ShellAndWaitSimple"
         Height          =   375
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Value           =   -1  'True
         Width           =   3735
      End
      Begin VB.OptionButton optEnhanced 
         Caption         =   "ShellAndWaitEnhanced"
         Height          =   375
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   3735
      End
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "Text1"
      Top             =   1320
      Width           =   4215
   End
   Begin VB.CommandButton btnShellToNotepad 
      Caption         =   "Shell To Notepad"
      Height          =   735
      Left            =   960
      TabIndex        =   5
      Top             =   4560
      Width           =   1335
   End
   Begin VB.Frame fraPassByOptions 
      Caption         =   "Specify Message Display Control"
      Enabled         =   0   'False
      Height          =   1215
      Left            =   240
      TabIndex        =   7
      Top             =   3240
      Width           =   4335
      Begin VB.OptionButton optDisplayByHWnd 
         Caption         =   "By HWnd Of Control"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   600
         Width           =   2295
      End
      Begin VB.OptionButton optDisplayByControl 
         Caption         =   "By Reference To Control"
         Enabled         =   0   'False
         Height          =   375
         Left            =   240
         TabIndex        =   3
         Top             =   240
         Value           =   -1  'True
         Width           =   2895
      End
   End
   Begin VB.Label Label1 
      Caption         =   "With ShelllAndWaitEnhanced, messages will be displayed in the text box below."
      Height          =   375
      Left            =   240
      TabIndex        =   10
      Top             =   840
      Width           =   4215
   End
   Begin VB.Label lblStatus 
      Caption         =   "Test Form For ShellAndWait"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   360
      TabIndex        =   8
      Top             =   120
      Width           =   4095
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' frmTest
' By Chip Pearson, chip@cpearson.com, www.cpearson.com
'
' Test form for the F_7_AB_1_ShellAndWaitEnhanced function and F_7_AB_1_ShellAndWaitSimple functions.
' On the form, the user select whether to use Simple or Enhanced, and in the case Enhanced, whether
' to pass the MessageControl with a reference to the control or by the HWnd of the control.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Constants
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' this is the number of seconds that each message in A_7_AB_1_MessageArray will be displayed
' on A_7_AB_1_MessageControl.
Private Const C_7_AB_1_MESSAGE_CYCLE_SECONDS As Long = 3&
' this is the number of milliseconds that the main loop will wait before popping the timer
' can calling DoEvents. This value is completely indendent of the A_7_AB_1_MessageCycleTimeSeconds
' parameter.
Private Const C_7_AB_1_DOEVENTS_MILLISECONDS As Long = 500&
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Win API Declares
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Declare Function PathFindOnPath Lib "shlwapi.dll" Alias "PathFindOnPathA" ( _
    ByVal pszPath As String, _
    ByVal ppszOtherDirs As String) As Long


Private Sub btnClose_Click()
    Unload Me
End Sub

Private Sub btnShellToNotepad_Click()
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' btnShellToNotepad_Click
' This button Shell's out to Notepad.exe, using either F_7_AB_1_ShellAndWaitSimple
' or F_7_AB_1_ShellAndWaitEnhanced
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Dim V_7_AB_1_Res As Long                    ' General purpose return code
Dim V_7_AB_1_CommandLine As String          ' The command line that will be passed to SHELL
Dim V_7_AB_1_MessageControl As VB.Control   ' A reference to the control on a form that will be used to
                                            ' display the mssages in V_7_AB_1_MessageArray. If this value is
                                            ' not NOTHING, V_7_AB_1_MessageHWnd must be 0.
Dim V_7_AB_1_MessageHWnd As Long            ' The HWnd of the control used to display the messages in V_7_AB_1_MessageArray.
                                            ' If this value is <> 0, must be NOTHING.
Dim V_7_AB_1_MessageArray As Variant        ' An array of strings containing the messages to display.
Dim V_7_AB_1_ErrorNumber As Long            ' General purpose error number variable.
Dim V_7_AB_1_ErrorText As String            ' General purpose error text variable.

''''''''''''''''''''''''''''''''''''''''''''''''''
' Ensure that "Notepad.exe" exists.
''''''''''''''''''''''''''''''''''''''''''''''''''
V_7_AB_1_Res = PathFindOnPath("Notepad.exe", vbNullString)
If V_7_AB_1_Res = 0 Then
    MsgBox "The ""Notepad.exe"" program cannot be found in any folder listed in the PATH environment variable.", _
        vbOKOnly, "SheetAndWait"
    Exit Sub
End If
        
V_7_AB_1_CommandLine = "Notepad.exe"
V_7_AB_1_MessageArray = Array("Please Wait.", "Running Notepad.", "Close NotePad when done.")

If Me.optSimple Then
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' We're doing a ShellAndWaitSimple. Call
    ' F_7_AB_1_ShellAndWaitSimple and wait for it to return.
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    V_7_AB_1_Res = F_7_AB_1_ShellAndWaitSimple(A_7_AB_1_CommandLine:=V_7_AB_1_CommandLine)
    MsgBox "ShellAndWaitSimple ended with a result of " & CStr(CBool(V_7_AB_1_Res))
Else
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' We're doing a ShellAndWaitEnhanced. Call
    ' F_7_AB_1_ShellAndWaitEnhanced and wait for it to return.
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    If Me.optDisplayByControl Then
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' We're passing a control in which to display the messages. Set
        ' V_7_AB_1_MessageControl to the textbox on the form, and set
        ' V_7_AB_1_MessageHWnd to 0&.  Then call F_7_AB_1_ShellAndWaitEnhanced
        ' and wait for it to return.
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Set V_7_AB_1_MessageControl = Me.Text1
        V_7_AB_1_MessageHWnd = 0&
        ' pass a control object A_7_AB_1_MessageControl to F_7_AB_1_ShellAndWaitEnhanced
        V_7_AB_1_Res = F_7_AB_1_ShellAndWaitEnhanced( _
                A_7_AB_1_CommandLine:=V_7_AB_1_CommandLine, _
                A_7_AB_1_MessageControl:=V_7_AB_1_MessageControl, _
                A_7_AB_1_MessageHWnd:=V_7_AB_1_MessageHWnd, _
                A_7_AB_1_MessageCycleTimeSeconds:=C_7_AB_1_MESSAGE_CYCLE_SECONDS, _
                A_7_AB_1_MessageArray:=V_7_AB_1_MessageArray, _
                A_7_AB_1_DoEventsMilliseconds:=C_7_AB_1_DOEVENTS_MILLISECONDS, _
                A_7_AB_1_ErrorNumber:=V_7_AB_1_ErrorNumber, _
                A_7_AB_1_ErrorText:=V_7_AB_1_ErrorText, _
                A_7_AB_1_MessageOnClose:="Shell'd Application has terminated.")
                

    Else
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' We're passing an HWnd in which to display the messages. Set
        ' V_7_AB_1_MessageControl to the Nothing, and set V_7_AB_1_MessageHWnd
        ' to the HWnd of the Text1 textbox. Then call F_7_AB_1_ShellAndWaitEnhanced
        ' and wait for it to return.
        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        Set V_7_AB_1_MessageControl = Nothing
        V_7_AB_1_MessageHWnd = Me.Text1.hwnd
        ' pass a control object A_7_AB_1_MessageControl to F_7_AB_1_ShellAndWaitEnhanced
        V_7_AB_1_Res = F_7_AB_1_ShellAndWaitEnhanced( _
                A_7_AB_1_CommandLine:=V_7_AB_1_CommandLine, _
                A_7_AB_1_MessageControl:=V_7_AB_1_MessageControl, _
                A_7_AB_1_MessageHWnd:=V_7_AB_1_MessageHWnd, _
                A_7_AB_1_MessageCycleTimeSeconds:=C_7_AB_1_MESSAGE_CYCLE_SECONDS, _
                A_7_AB_1_MessageArray:=V_7_AB_1_MessageArray, _
                A_7_AB_1_DoEventsMilliseconds:=C_7_AB_1_DOEVENTS_MILLISECONDS, _
                A_7_AB_1_ErrorNumber:=V_7_AB_1_ErrorNumber, _
                A_7_AB_1_ErrorText:=V_7_AB_1_ErrorText)
    End If
    
    If V_7_AB_1_Res <> 0 Then
        MsgBox "ShellAndWaitEnhanced ended with a result of: " & CStr(CBool((V_7_AB_1_Res)))
    Else
        MsgBox "ShellAndWaitEnhanced ended with a result of: " & CStr(CBool((V_7_AB_1_Res))) & vbCrLf & _
            "ShellAndWait Error Number: " & CStr(V_7_AB_1_ErrorNumber) & vbCrLf & _
            "Error Description: " & V_7_AB_1_ErrorText
    End If

End If

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This function is called when the form is closed. We need to determine
' whether to cancel the close, or call KillTheTimer and close the
' process handle and allow the unload to proceed.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Select Case UnloadMode
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' determine the reason that the form is being unloaded
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Case vbFormControlMenu, vbFormCode
        ''''''''''''''''''''''''''''''''''''''''''''''
        ' the user is shutting us down
        ''''''''''''''''''''''''''''''''''''''''''''''
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' See if we're running an ShellAndWaitEnhanced command
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        If F_7_AB_1_ShellEhancedStillRunning = True Then
            If MsgBox("The shelled program in ShellAndWaitEnhanced: " & vbCrLf & _
                F_7_AB_1_GetEnhancedCommmandLine() & vbCrLf & _
                "is still running. Are you sure you want to close this form?", vbYesNo, _
                "ShellAndWaitEnhanced") = vbNo Then
                Cancel = True
            Else
                F_7_AB_1_AbortShellAndWaitEnhanced
            End If
        End If
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' See if we're running an ShellAndWaitSimple command
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        If F_7_AB_1_ShellSimpleStillRunning = True Then
            If MsgBox("The shelled program in ShellAndWaitSimple: " & vbCrLf & _
                F_7_AB_1_GetSimpleCommmandLine() & vbCrLf & _
                "is still running. Are you sure you want to close this form?", vbYesNo, "ShellAndWait") = vbNo Then
                Cancel = True
            Else
                F_7_AB_1_AbortShellAndWaitSimple
            End If
        End If
        
        
    Case Else
        ''''''''''''''''''''''''''''''''''''''''''''''''''
        ' the system or the ownerform is shutting us down.
        ' abort the ShellAndWait for both simple and
        ' advanced (it is harmless to abort a routine
        ' that isn't running).
        '''''''''''''''''''''''''''''''''''''''''''''''''
        F_7_AB_1_AbortShellAndWaitSimple
        F_7_AB_1_AbortShellAndWaitEnhanced

End Select

End Sub

Private Sub optEnhanced_Click()
    If Me.optEnhanced = False Then
        Me.fraPassByOptions.Enabled = False
        Me.optDisplayByControl.Enabled = False
        Me.optDisplayByHWnd.Enabled = False
    Else
        Me.fraPassByOptions.Enabled = True
        Me.optDisplayByControl.Enabled = True
        Me.optDisplayByHWnd.Enabled = True
    End If
End Sub

Private Sub optSimple_Click()
    If Me.optSimple = False Then
        Me.fraPassByOptions.Enabled = True
        Me.optDisplayByControl.Enabled = True
        Me.optDisplayByHWnd.Enabled = True

    Else
        Me.optDisplayByControl.Enabled = False
        Me.optDisplayByHWnd.Enabled = False
        Me.fraPassByOptions.Enabled = False
    End If
    
End Sub
